var _ = require('lodash')
  , HapiMeal = require('hapi-meal');

/**
 * Home controller
 * @type {Function}
 */
var UserController = module.exports = function UserController () {
  HapiMeal.Controller.prototype.constructor.apply(this, arguments);
};

_.extend(
  UserController.prototype,
  HapiMeal.Controller.prototype
);

_.extend(
  UserController.prototype,
  {
    /**
     * Login action
     * @param request
     * @param data
     * @return {*}
     */
    loginAction:function (request, data) {
      if (!data.user) {
        data.title = 'Login';

        if (request.method === 'post') {
          // Validate query
          var Passport = this.app.server.plugins.travelogue.passport;
          Passport.authenticate('local', {
            successRedirect: this.app.settings.plugins.travelogue.urls.successRedirect,
            failureRedirect: this.app.settings.plugins.travelogue.urls.failureRedirect
          })(request);

        } else {
          return request.reply.view(data.viewName, data);
        }

      // Redirect logged users
      } else {
        return request.reply.redirect('/');
      }
    },

    socialAuth: function (request, type, options) {
      var Passport = this.app.server.plugins.travelogue.passport;
      Passport.authenticate(type, options)(request);
    },

    facebookLoginAction: function(request, data) { this.socialAuth(request, 'facebook', { scope: ['email', 'user_location'] }); },
    twitterLoginAction: function(request, data) { this.socialAuth(request, 'twitter'); },

    socialAuthCallback: function (request, type) {
      try {
        var Passport = this.app.server.plugins.travelogue.passport;
        Passport.authenticate(
          type, this.app.settings.plugins.travelogue.urls
        )(request);

      } catch (error) {
        request.reply.redirect('/user/login?auth_error');
      }
    },

    facebookLoginCallbackAction: function(request, data) { this.socialAuthCallback(request, 'facebook'); },
    twitterLoginCallbackAction: function(request, data) { this.socialAuthCallback(request, 'twitter'); }
  });
